#!/usr/bin/perl -w

# This file was taken almost completely from the old index.php3 in the
# prototype. It makes the same mistakes that its predecssor does. At
# the size it is, this is probably alright. :) One example is the way it does
# column breaks halfway though which is nasty compared to the way it is done
# completely in the templates everywhere else in the code

# it was redesgined in large part when it was seperated from calf


use strict;
use Template;
use POSIX;
use Calf::Config qw( :base );
use Calf::Utils qw( :template :db );
use Calf::Auth qw( :base );

use CGI;

$| = 1;
#print "Content-type: text/html\n\n";
my $file = 'index.html';

### Get the Necessary Data From the Database
############################################
my $dbh = Calf::Utils::open_db;                            # open the database
my $q = new CGI;
my ( $sth, $select_statement );

my $session_info = &valid_id( $q, $dbh ); # is the person logged in?
my ( $editor );

if ( defined( $session_info ) ) {      # if the person is logged in.
  $editor = 1;                         # mark them as an editor
}

my $vars = {
            session_info          => $session_info,
	    editor                => $editor,
	    total_list_count      => &get_count,
	    types                 => &get_types,
	   };

&process_template($file, $vars);
$dbh->disconnect;  # disconnect from the database

## SUBROUTINES
############################################

# find the total number of lists in the database
sub get_count {
  $select_statement = qq/ SELECT COUNT(*) AS CNT FROM calf_data
                          WHERE recommended <= $rec_thresh
                          AND approved = 1 /;
  $sth = $dbh->prepare( $select_statement )
    || &db_error( "prepare", $!, $select_statement );
  $sth->execute
    || &db_error( "execute", $!, $select_statement );
  my $count = ( $sth->fetchrow_array )[0];
  $sth->finish || &db_error( "finish", $! );

  return $count;
}

# grab and return each of the possible types
sub get_types {
  my( $type, $values );

  foreach $type (@types)
    { $values->{"$type"} = ( &get_type_list( $type ) ); }
  return( $values );
}

# grab the description, the code, and the total number of lists in the
# database for each type
sub get_type_list {
  my $type = $_[0];
  my @type_list;
  my $half_type_list_length;
  $select_statement = qq/ SELECT $type.description AS description,
			  $type.code AS code,
			  COUNT(calf_data.description) AS cnt
			  FROM calf_data, $type
			  WHERE
                          recommended <= $rec_thresh
                          AND approved = 1
                        /;
  $select_statement .= qq/ AND calf_data.$type LIKE CONCAT('%',$type.code,'%')
                           GROUP by $type.description /;
  $sth = $dbh->prepare( $select_statement )
    || &db_error( "prepare", $!, $select_statement );
  $sth->execute
    || &db_error( "execute", $!, $select_statement );

  while (my $hash_ref = $sth->fetchrow_hashref('NAME_lc')) {# pull the data out
    # as a hash_ref
    # for each hash_ref (representing a row from the database, copy the
    # ref into @type_list each hashref should have the keys: 'description',
    # 'code' and 'cnt'
    push @type_list, { %$hash_ref };
  }

  return (\@type_list);

}
